#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <SDL.h>
#include <SDL_image.h>

int main()
{
	SDL_Surface * screen;
	SDL_Surface * window;
	SDL_Surface * img;
    SDL_Surface * temp;        

    SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);
    atexit(SDL_Quit);
    
    // init screen
    screen = SDL_SetVideoMode(800, 600, 0, SDL_SWSURFACE); 
    Uint32 fill_color = SDL_MapRGB(screen->format, 0xFF, 0xFF, 0xFF);
    SDL_FillRect(screen, NULL, fill_color);

    // load img
    temp = IMG_Load("img.png");     
    img = SDL_DisplayFormatAlpha(temp);     
    SDL_Rect rect = { 10, 10, 0, 0};
        
    // blit img on screen
    SDL_BlitSurface(img, NULL, screen, &rect);

    // create transparent surface
    window = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, img->w , img->h, 
                                  img->format->BitsPerPixel, 
                                  img->format->Rmask, img->format->Gmask, 
                                  img->format->Bmask, img->format->Amask);  
        
    // blit img on window    
    SDL_BlitSurface(img, NULL, window, NULL);
    
    // blit window on screen
    rect.x = 400;
    rect.y = 10;        
    SDL_BlitSurface(window, NULL, screen, &rect);
        
    SDL_Flip(screen);   
    
    int done = 0;
    SDL_Event event;

    while(!done)    
    {         
        while(SDL_PollEvent(&event))
        {
            if( event.type == SDL_QUIT )  
                done = 1;  

            else if( event.type == SDL_KEYDOWN )
            {
                switch(event.key.keysym.sym)
                {
                    case SDLK_ESCAPE:
                        done = 1; 
                        break;                        
                }
            }
        }
        
        SDL_Delay(10);
    }
    
    return 0;
}
