#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <SDL.h>
#include <SDL_image.h>

Uint32 getpixel(SDL_Surface *surface, int x, int y);
void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel);

int main()
{
	SDL_Surface * screen;
	SDL_Surface * window;
    SDL_Surface * window2;
	SDL_Surface * img;
    SDL_Surface * img2;
    SDL_Surface * temp;
    
    int x, y;    
    
    SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);
    atexit(SDL_Quit);
    
    // init screen
    screen = SDL_SetVideoMode(800, 600, 0, SDL_SWSURFACE); 
    Uint32 fill_color = SDL_MapRGB(screen->format, 0xFF, 0xFF, 0xFF);
    SDL_FillRect(screen, NULL, fill_color);

    SDL_Rect rect = { 10, 10, 0, 0};  
    
    // load images
    temp = IMG_Load("img.png"); 
    img = SDL_DisplayFormatAlpha(temp);      
    temp = IMG_Load("img2.png");     
    img2 = SDL_DisplayFormatAlpha(temp);     
        
    // blit img on screen
    SDL_BlitSurface(img, NULL, screen, &rect);

    // create transparent surfaces
    window = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, img->w , img->h, 
                                  img->format->BitsPerPixel, 
                                  img->format->Rmask, img->format->Gmask, 
                                  img->format->Bmask, img->format->Amask);  
    
    window2 = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, img->w , img->h, 
                                   img->format->BitsPerPixel, 
                                   img->format->Rmask, img->format->Gmask, 
                                   img->format->Bmask, img->format->Amask);  

    // copy img on window
    SDL_LockSurface(window);
    SDL_LockSurface(img);    
    memcpy(window->pixels, img->pixels, (img->w * img->h * img->format->BytesPerPixel));
    SDL_UnlockSurface(window);
    SDL_UnlockSurface(img);    
    
    // blit img2 on window2
    SDL_LockSurface(window);
    SDL_LockSurface(img);    
    for(x = 0; x < img2->w; x++)
    {
        for(y = 0; y < img2->h; y++)
            putpixel(window2, x, y, getpixel(img2, x, y));
    }    
    SDL_UnlockSurface(window);
    SDL_UnlockSurface(img);
                    
    
    // blit window on screen
    rect.x = 400;
    rect.y = 10;        
    SDL_BlitSurface(window, NULL, screen, &rect);
    
    // blit window2 on screen
    rect.x = 400;
    rect.y = 210;        
    SDL_BlitSurface(window2, NULL, screen, &rect);
        
    SDL_Flip(screen);   
    
    int done = 0;
    SDL_Event event;

    while(!done)    
    {         
        while(SDL_PollEvent(&event))
        {
            if( event.type == SDL_QUIT )  
                done = 1;  

            else if( event.type == SDL_KEYDOWN )
            {
                switch(event.key.keysym.sym)
                {
                    case SDLK_ESCAPE:
                        done = 1; 
                        break;                        
                }
            }
        }
        
        SDL_Delay(10);
    }
    
    return 0;
}

Uint32 getpixel(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
        case 1:
            return *p;

        case 2:
            return *(Uint16 *)p;

        case 3:
            if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
                return p[0] << 16 | p[1] << 8 | p[2];
            else
                return p[0] | p[1] << 8 | p[2] << 16;

        case 4:
            return *(Uint32 *)p;

        default:
            return 0;       /* shouldn't happen, but avoids warnings */
    }
}


void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
        case 1:
            *p = pixel;
            break;

        case 2:
            *(Uint16 *)p = pixel;
            break;

        case 3:
            if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
                p[0] = (pixel >> 16) & 0xff;
                p[1] = (pixel >> 8) & 0xff;
                p[2] = pixel & 0xff;
            } else {
                p[0] = pixel & 0xff;
                p[1] = (pixel >> 8) & 0xff;
                p[2] = (pixel >> 16) & 0xff;
            }
            break;

        case 4:
            *(Uint32 *)p = pixel;
            break;
    }
}


